#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sysexits.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <strfunc.h>

#include "lgba.h"
#include "cgi.h"

char *option_classes();
char *option_nodes();
char *option_map(char *, char *);

extern char *usenode, *object;

extern slist *class, *classes, *nodes;

extern char *user;

int tryReadConfig(char *cfname);

char *cf(char *cs) {
	cs=cfgget(cs);
	if(cs) return cs;
	return "";
};

int main() {
	char *p;
	slist *attrs=NULL;
	slist *tl;
	int n;
	char **vp;
	slist *was=NULL;
	long on = 1;
	int needReload = 0;

	if(tryReadConfig(NULL)) {
			printf("Content-type: text/html\n\n"
			"Failed to read config.");
			exit(EX_NOINPUT);
	};

	classes=cfgget2("classes");
	nodes=cfgget2("nodes");

	printf("%s\n\n", cf("content-type"));
	fflush(stdout);

	class=scopy(param2("objectclass", 0));
	usenode=param("node");
	attrs=params();

	lgba_ctl(LCTL_SET_HTMLMODE, &on);
	lgba_ctl(LCTL_SET_USE_LOCALE, &on);

	if((n=lgba_init(NULL))) {
		printf("Error in lgba_init(): %s.\n", lgba_err2string(n));
		printf("%s", FOOTER);
		exit(2);
	};

	if((n=lgba_open()) || (usenode && *usenode && (n=lgba_chnode(usenode)))) {
		printf("Error in lgba_open() or lgba_chnode(%s): %s.\n", usenode, lgba_err2string(n));
		printf("%s", FOOTER);
		exit(2);
	};

	/* Setting privilege level. */
	setgid(getegid());
	setgid(84);
	if(!(p=getenv("REMOTE_USER"))) p = "unknown";
	if(lgba_setuser(p) != 0) {
		printf("Error setting previlege level.\n");
		exit(0);
	};

	object=param("~");


	if((tl=getlanguageprefs())) {
		int i;
		for(i = 0; i < tl->count; i++)
			if(lgba_setlang(tl->list[i]))
				break;
	};

	if(!object || load(object)) {
		printf("%s", getformat(cf("not_found")));
		printf("%s", FOOTER);
		exit(2);
	};

	/* Remember the main object name */
	object = sf_strdup(lgba_objectname());

	was=sinit();
	sadd(was, "~");
	sadd(was, "node");
	sadd(was, "object");
	sadd(was, "objectclass");

	/* Changing object class */
	if(class->count) {
		char **clss;
		register char **vp2;

		vp = class->list;
		for(vp2 = vp; *vp2; vp2++)
			addclass(*vp2);

		for(clss = lgba_objectclass(); *clss; clss++)
			if(cfind(vp, *clss) == -1)
				rmclass(*clss);

		needReload = 1;
    };

	/* Changing generic attributes */
	for(n=0; n < attrs->count; n++) {
		if(scfind(was, attrs->list[n]) != -1)
			continue;
		sadd(was, attrs->list[n]);
		setattr2(attrs->list[n], mkarray(param2(attrs->list[n], 0), 0));
		needReload = 1;
	};

	/* Changind object name */
	if( (n = scfind(attrs, "object")) != -1) {
		setattr2("object", mkarray(param2(attrs->list[n], 0), 0));
		needReload = 1;
		if(!ecq(object, lgba_objectname())) {
			needReload = 0;	/* Already reloaded */
			free(object);
			object = lgba_objectname();
		};
	};

	if(needReload) {
		if(load(object)) {
			printf("%s", getformat(cf("not_found")));
			printf("%s", FOOTER);
			exit(2);
		};
		free(object);
		object = lgba_objectname();
	};

lgba_addfriendly("cgi(SCRIPT_NAME)", (p=getenv("SCRIPT_NAME"))?p:"add.cgi");
lgba_addfriendly("cgi(object)", object?object:"");
lgba_addfriendly("cgi(node)", usenode?usenode:"");
lgba_addfriendly("cgi(option_classes)", option_classes());
lgba_addfriendly("cgi(option_nodes)", option_nodes());

if(object) printf("%s", getformat(cf("edit_head")));
else {
	printf("%s%s", getformat(cf("edit_head")), getformat(cf("edit_tail")));
	lgba_close();
	printf("%s", FOOTER);
	exit(0);
};

{
	char *fr;
	char *at;
	char **wrl;
	slist *sl;
	slist *rdo;
	char **vp;
	char *ha_filter;
	int tpe;
	char *edit_unknown=cf("edit_unknown");
	char *edit_unknown_text=cf("edit_unknown_text");
	char *edit_unknown_map=cf("edit_unknown_map");
	char *edit_unknown_password=cfgget("edit_unknown_password");
	slist *edit_define_known=cfgget2("edit_define_known");
	slist *values;

	if(!edit_unknown_password)
			edit_unknown_password = edit_unknown;

	wrl=lgba_getwritelist();
	sl=sinit();
	rdo=sinit();

	{ long off = 0; lgba_ctl(LCTL_SET_OVERRIDEMODE, &off); };

	fflush(stdout);

	while((at=lgba_next_attribute())) {
		ha_filter=edit_unknown;
		if(scfind(cfgget2("edit_define_known"), at) != -1) continue;
		sadd(sl, at);
		if((tpe=lgba_gettype(at)) & TY_BINARY) continue;
		if(!canIread(at)) continue;
		if(!canIwrite(at)) { sadd(rdo, at); continue; };
		if(tpe & TY_TEXT) ha_filter=edit_unknown_text;
		if(tpe & TY_MAP) ha_filter=edit_unknown_map;
		if((tpe & TY_PASSWD) || (tpe & TY_CRYPTPW))
			ha_filter=edit_unknown_password;

		fr=lgba_map_friendly(at);
		if(ha_filter == edit_unknown_map) {
			if((values = getattr2(at))) {
				for(vp = values->list; *vp; vp++) {
					p=replace(ha_filter, "%m",
						option_map(lgba_gettypespec(at), *vp));
					p=replace(p, "$`%a'", fr);
					p=replace(p, "%a", at);
					format(p, 1);
				};
			};
			if(!(tpe & TY_SINGLE)) {
				p=replace(cf("edit_newvalue"), "$`%a'", fr);
				p=replace(p, "%a", at);
				format(p, 1);
			};
		} else if(ha_filter == cf("edit_unknown_readonly")) {
			p=replace(ha_filter, "$`%a'", fr);
			p=replace(p, "%a", at);
			format(p, 1);
		} else {
			p=replace(ha_filter, "$`%a'", fr);
			p=replace(p, "%a", at);
			format(p, 1);
			if(!(tpe & TY_SINGLE)) {
				p=replace(cf("edit_newvalue"), "$`%a'", fr);
				p=replace(p, "%a", at);
				format(p, 1);
			};
		};
	};

	if(wrl) {
		for(; *wrl; wrl++) {
		p=edit_unknown;
		if(scfind(edit_define_known, *wrl) != -1) continue;
		if(scfind(sl, *wrl) != -1) continue;
		if(eq(*wrl, "*") || **wrl=='!') continue;
		if((tpe=lgba_gettype(*wrl)) & TY_BINARY)
			continue; /* We doesn't know how to handle binary values. */
		if(!canIread(*wrl)) continue;
		if(!canIwrite(*wrl)) { sadd(rdo, *wrl); continue; };
		if(tpe & TY_TEXT) p=edit_unknown_text;
		if(tpe & TY_MAP) {
			p=edit_unknown_map;
			p=replace(p, "%m", option_map(lgba_gettypespec(*wrl), *wrl));
		};

		p=replace(p, "$`%a'", lgba_map_friendly(*wrl));
		p=replace(p, "%a", *wrl);
		format(p, 1);
	    };
	};

	{ long on = 1; lgba_ctl(LCTL_SET_OVERRIDEMODE, &on); };

	wrl=sarray(rdo, 0)-1;
	ha_filter=cf("edit_unknown_readonly");
	while(*(++wrl)) {
		p=replace(ha_filter, "$`%a'", lgba_map_friendly(*wrl));
		p=replace(ha_filter, "%a", *wrl);
		format(p, 1);
	};

};

	printf("%s", getformat(cf("edit_tail")));
	lgba_close();
	printf("%s", FOOTER);

	return 0;
}

char *option_classes() {
	sbuf *sb;
	char *buf;
	char **vp=sarray(classes, 0);
	char **clss=lgba_objectclass();

	if(!vp) return 0;

	sb = sbuf_init();

	while(*vp) {
		sbuf_sprintf(sb,
		"<INPUT TYPE=checkbox NAME=objectclass VALUE=\"%s\"%s> %s",
		*vp, cfind(clss, *vp)!=-1?" checked=on":"", *vp);
		if(*(++vp))
			sbuf_add(sb, ", ");
	}

	buf = sb->buf;
	free(sb);
	return buf;
};

char *option_map(char *sp, char *value) {
	static slist *a=NULL;
	static slist *v=NULL;
	sbuf *sb;
	int k;

	if(a) sclear(a);
	if(v) sclear(v);
	lgba_readavfile(sp, &a, &v);

	sb = sbuf_init();

	for(k=0; k < a->count; k++) {
		sbuf_sprintf(sb, "<OPTION VALUE=\"%s\"%s>%s", a->list[k], ecq(a->list[k],value)?" selected=on":"", v->list[k]);
	};

	return sbuf_detach(sb, NULL, NULL);
};



