#include <unistd.h>
#include <stdlib.h>
#include <strfunc.h>
#include <lgba.h>
#include <err.h>
#include <stdio.h>
#include <sys/stat.h>

int crfunc(int);

int main()
{

	if(lgba_init(NULL))
		errx(1, "LGBA Init error.");

	if(lgba_open())
		errx(1, "LGBA Open error.");

	lgba_setuser("root");

	{
		char *avl[]={"cn",
			"objectclass",
			"uid", "gid",
			"shell", "home",
			lgba_ObjectAttribute(), NULL};
		lgba_setattrlist(avl);
	};

	lgba_search(NULL, "(&(objectclass=Person)(home=*))",
		NULL, NULL, NULL, NULL, crfunc, 0);

	return 0;
}

int crfunc(int zzz) {
	struct stat t;
	char *home=getattr("home");
	char *uid=getattr("uid");
	char *gid=getattr("gid");

	(void) zzz;

	if(!stat(home,&t) || !*home || !strcmp(home,"/nonexistent"))
		return 0;

	printf("%s\n", getformat("${}. ${~[0]},${uid},${gid}: ${home}"));

	if(mkdir(home, 0755))
		perror("mkdir");
	else
		if(chown(home, atoi(uid), atoi(gid)))
			perror("chown");

	return 0;
};


