#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <lgba.h>
#include <string.h>
#include <strfunc.h>

char *oc=NULL;
char *t=NULL;
char *t4=NULL;
char *utv=NULL;
char *cln=NULL;
int zeroize_attr=0;

int dofunc(int);

int main(int ac, char **av) {
	int ca;
	slist *sl;


	if(ac == 1) {
		fprintf(stderr,
"LGBA Resource decreaser
	Copyright (c) 2000, 2001
	Lev Walkin <vlm@spelio.net.ru>, Alexandr Grigoryev <ga@ulstu.ru>

Usage: %s [-n <lgba_node>] {<objectclass>|<ldapfilter>} [-z] <timeleft_attr> <time4period_attr> [<timemax_attr> [<clean_attr>]]
", *av);
		exit(2);
	};

	setgid(84);

	if(lgba_init(NULL) || lgba_open()) {
		lgba_perror("LGBA Init error");
		exit(2);
	};

	if(lgba_setuser("root")) {
		lgba_perror("Set user(\"root\") failed.");
		exit(2);
	};


	ca=1;
	if(*av[1] == '-') {
		if(ac < 3 || !eq(av[1], "-n")) {
			fprintf(stderr, "Error: [-n <lgba_node>] required\n");
			exit(2);
		};
		if(lgba_chnode(av[2])) {
			lgba_close();
			fprintf(stderr, "Error: Failed to change node...\n");
			exit(2);
		};
		fprintf(stderr, "LGBA Node changed to '%s'.\n", av[2]);
		ca=3;
	};

	if(ac <= ca) {
		fprintf(stderr, "Error: mandatory parameter missing.\n");
		exit(2);
	};

	sl=sinit(NULL);

	oc=av[ca];

	if(!strchr(oc, '=')) {
		oc = sf_malloc(strlen(oc) + 32);
		sprintf(oc, "(objectclass=%s)", av[ca]);
	}

	if(*av[ca+1] == '-') {
		if(eq(av[ca+1], "-z")) {
			zeroize_attr = 1;
			ca++;
		} else {
			fprintf(stderr, "Error: Unknown option %s\n", av[ca+1]);
			exit(2);
		}
	};

	if(ac > ++ca) t=av[ca]; sadd(sl, t);
	if(ac > ++ca) t4=av[ca]; sadd(sl, t4);
	if(ac > ++ca) utv=av[ca]; sadd(sl, utv);
	if(ac > ++ca) cln=av[ca]; sadd(sl, cln);

	if(!t || !strlen(t) || !t4 || !strlen(t4) || (utv && !strlen(utv))) {
		fprintf(stderr, "Error: Parameter missing or empty.\n");
		exit(2);
	};

	lgba_search(NULL, oc, sarray(sl, 0), NULL, NULL, NULL, dofunc, 0);

	lgba_close();

	return 0;
};



int
dofunc(int z) {
	register char *s;
	register int t_, t4_, utv_;
	static char fornum[64];

	s=getattr(t);
	if(!*s) return 0;

	t_=atoi(s);
	t4_=atoi(getattr(t4));
	if(!t4_) return 0;

	printf("User %s, %s=%s+%s\n",
		lgba_objectname(),
		t,
		zeroize_attr?"0":getattr(t),
		getattr(t4));

	if(zeroize_attr) {
		sprintf(fornum, "%d", t4_);
	} else {
	    if(utv) {
		if((utv_=atoi(getattr(utv)))) {
		  if(t_ + t4_ > utv_) {
			sprintf(fornum, "=%d", utv_);
			goto ex;
		  };
		} else {
			sprintf(fornum, "=%d", t4_);
			goto ex;
		};
	    };

	    sprintf(fornum, "%+d", t4_);
	};

ex:
	setattr(t, fornum);
	setattr(cln, "=0");

	lgba_save(1);

	return 0;
};



