
#ifndef	__STDC__
#define	__STDC__
#endif

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef	HAVE_FNMATCH_H
#include <fnmatch.h>
#endif

#include <strfunc.h>

#include "readcf.h"
#include "lgba.h"
#include "intern.h"

/* -1 - unconditional deny; 0 - deny; 1 - allow; */
int lgba_i_getaccess(const char *classname, const char *field, int act) {
	oca *oc;
	acl *ac=NULL;

	if(!(oc=lgba_i_findclass(classname))) return 0;

	switch(act) {
		case AC_CREATE:	ac=oc->create; break;
		case AC_DELETE:	ac=oc->delete; break;
		case AC_READ:	ac=oc->read; break;
		case AC_WRITE:	ac=oc->write; break;
		default: return 0;
	}

	if(!ac) return 0;

	return lgba_i_findaclreg(ac, field);
};

/* 2 - unconditional deny; 1 - deny; 0 - allow */
int lgba_i_denied(char **classnames, const char *field, int act) {
	int deny=1;
	if(!classnames) return 0;

	for(; *classnames; classnames++)
		switch(lgba_i_getaccess(*classnames, field, act)) {
			case -1:
				return 2;
			case 1:
				deny=0;
				break;
		};

	return deny;
}

oca *
lgba_i_findclass(const char *classname) {
	oca *oc=lgba_i_ocahead;
	if(!classname) return NULL;
	while(oc) {
		if(ecq(oc->classname, classname)) return oc;
		 oc=oc->next;
	}
	return NULL;
}

int
lgba_i_findaclreg(acl *ac, const char *at) {
	int i, j;
	slist *us;
	int not=0;
	int not_own_node=0;


#ifndef	FNM_CASEFOLD
	char *c;

	if(!at)
		return -1;

	c = (char *)at;
	(char *)at = (char *)alloca(strlen(at) + 1);
	if(!at) abort();	/* Stack overflow */
	strcpy((char *)at, c);
	for(c = (char *)at; *c; c++)
		*c = tolower(*c);
#else

	if(!at)
		return -1;

#endif

	while(ac) {
	  us = ac->users;
	  for(i=0; i < us->count; i++) {

	    if(ecq2(us->list[i], "self")) {

			if(not_own_node) continue;

			if(!lgba_i_defaultnode
				|| !lgba_i_node
				|| !lgba_i_node->name
				|| !ecq(lgba_i_defaultnode, lgba_i_node->name)
			) {
				not_own_node=1;
				continue;
			};

			if((scfind(getattr2(lgba_ObjectAttribute()), lgba_i_user) == -1))
				continue;

		/* us->list[] and lgba_i_user are already lower-cased */
		} else if(fnmatch(us->list[i], lgba_i_user, 0) != 0) {
			continue;
		}
	
		for(j=0; j < ac->attrlist->count; j++) {
			if(*ac->attrlist->list[j] == '!') {

				/* reverse sign */
				if(!*(ac->attrlist->list[j]+1)) {
					not=not?0:1;
					continue;
				};

				/* unconditional deny, if found "!at" */
				if(fnmatch(ac->attrlist->list[j]+1, (char *)at,
#ifdef	FNM_CASEFOLD
					FNM_CASEFOLD) == 0)
#else
					0) == 0)
#endif
					return -1;

				continue;
			};

			/* if found an attribute or an asterisk, return */
			if(*ac->attrlist->list[j] == '*' ||
				fnmatch(ac->attrlist->list[j], (char *)at,
#ifdef	FNM_CASEFOLD
				FNM_CASEFOLD) == 0)
#else
				0) == 0)
#endif
					return not?-1:1;
		}; /* for(attributes) */
	

	  }; /* for(users) */

	  ac=ac->next;
	};

	return 0;
}

int lgba_i_override=1;

char **
lgba_internal_override(char *key, void *key2) {
	static int entr=0;
	char **res=NULL;
	Override *ov=lgba_i_ovr_head;
	static char *vp[]={NULL, NULL};

	(void)key2;

	if(!key) return NULL;

	/* Passed ${} */
	if(!*key) {
		*vp = genstr(lgba_i_counter);
		return vp;
	};

	/* Passed ${~} */
	if(*key == '~' && !key[1]) {
		return sarray(getattr2(lgba_ObjectAttribute()), 0);
	};

	if(!canIread(key)) {
		*vp="<protected>";
		return vp;
	};

	if(entr || !key || !ov) return sarray(getattr2(key), 0);
	if(!lgba_i_override) return sarray(getattr2(key), 0);

	entr=1;

	while(ov) {
		if(ecq(ov->attr, key)) {
			if(ov->func) {
				res=ov->func(res?res:sarray(getattr2(key), 0), key);
			} else {
				*(res=vp)=getformat(ov->to);
			}
		};
		ov=ov->next;
	}

	entr=0;

	return res?res:sarray(getattr2(key), 0);
};

int lgba_i_validate(const char *key, const char *val) {
	int result, r2;
	int i;
	Validate *vl=lgba_i_val_head;

	if(!key || !val) return 0;

	/* passing everything */
	if(!vl) return 1;

	result = -1;

	while(vl) {
		if(sfind(vl->attrs, key) != -1) {

	/* compile regex_t's if isn't ready. */
	if(!vl->REs->count) {
		int i;
		regex_t *tmp;
		for(i=0; i < vl->exprs->count; i++) {
			tmp=(regex_t *)sf_malloc(sizeof(regex_t));
			memset(tmp, 0, sizeof(regex_t));
			sadd2(vl->REs, (char *)tmp, sizeof(regex_t));
			if(regcomp((regex_t *)vl->REs->list[i],
				vl->exprs->list[i],
				REG_EXTENDED | REG_NOSUB))
			fprintf(stderr, "~WARN: Error compiling regular expression '%s', recheck the configuration.", vl->exprs->list[i]);
		};
	};

			r2=-1;
			for(i=0; i < vl->REs->count; i++) {
				if(regexec((regex_t *)vl->REs->list[i], val,
					0, NULL, 0) != 0) {
					r2 = 0;
					break;
				} else {
					r2 = 1;
				};
			};
			if(r2 == 1) return 1;
			else if(r2 == 0) result=0;
		}; /* found key in attributes */
		vl=vl->next;
	};

	
	return (result==-1)?1:result;
}

int lgba_i_validate2(const char *key, const char **vals) {
	char **vp;

	if(!key || !vals) return 0;

	for(vp=(char **)vals; *vp; vp++)
		if(lgba_i_validate(key, *vp) == 0)
			return 0;

	return 1;
}

int canIcreate(const char *at) {
	if(!loaded.objectclass) return 0;
	if(lgba_i_denied(loaded.objectclass->list, at, AC_CREATE)) return 0;
	return 1;
}

int canIread(const char *at) {
	if(!loaded.objectclass) return 0;
	if(lgba_i_denied(loaded.objectclass->list, at, AC_READ)) return 0;
	return 1;
}

int canIwrite(const char *at) {
	if(!loaded.objectclass) return 0;
    if(lgba_i_denied(loaded.objectclass->list, at, AC_WRITE)) return 0;
    return 1;
}

int canIdelete(const char *at) {
	if(!loaded.objectclass) return 0;
	if(lgba_i_denied(loaded.objectclass->list, at, AC_DELETE)) return 0;
	return 1;
}


