%{

#include <stdio.h>
#include <string.h>

#include <strfunc.h>

#include "readcf.h"
#include "friendly.h"
#include "lgba.h"
#include "file.h"
#include "intern.h"
#include "gram.h"

int lgba_i_nline=1;
extern int yylex();
extern int yyerror();

slist *lgba_i_cf_tmp_frF=NULL;
slist *lgba_i_cf_tmp_frT=NULL;
slist *lgba_i_cf_tmp_bs=NULL;
slist *lgba_i_cf_tmp_fattrlist=NULL;

acl *lgba_i_cf_tmp_acl_c;
acl *lgba_i_cf_tmp_acl_r;
acl *lgba_i_cf_tmp_acl_w;
acl *lgba_i_cf_tmp_acl_d;

char *lgba_i_cf_tmp_a=NULL;
char *lgba_i_cf_tmp_b=NULL;
char *lgba_i_cf_tmp_c=NULL;
char *lgba_i_cf_tmp_d=NULL;
char *lgba_i_cf_tmp_e=NULL;
char *lgba_i_cf_tmp_f=NULL;
char *lgba_i_cf_tmp_g=NULL;
char *lgba_i_cf_tmp_scn=NULL;

int lgba_i_cf_tmp_int_a=0;
int lgba_i_cf_tmp_int_b=0;
int lgba_i_cf_tmp_int_c=0;
int lgba_i_cf_tmp_int_d=0;

char *lgba_i_cf_tmp_cr;
char *lgba_i_cf_tmp_cd;
char *lgba_i_cf_tmp_mr;
char *lgba_i_cf_tmp_md;
char *lgba_i_cf_tmp_oa;

char *onpos=NULL;
char *onzer=NULL;
char *onneg=NULL;

%}

/*
 * Token value definition
 */
%union {
	int  tv_int;
	char *tv_char;
	void *tv_void;
	struct Tavpair tv_avpair;
	struct Tovvar tv_ovvar;
	slist *tv_slist;
	slistpair tv_slistpair;
	Validate tv_validate;
}

/*
 * Token types returned by scanner
 */
%token <tv_char>	TOK_STRING
%token <tv_int>		TOK_INTEGER

%type	<tv_slist>	attr_list
%type	<tv_avpair>	avpair
%type	<tv_ovvar>	override_var
%type	<tv_slistpair>	av_list
%type	<tv_validate>	validate_var
%type	<tv_void>	validate_defs

/*
 * Reserved words
 */
%token				EQ
%token				LB
%token				RB
%token				COMMA
%token				COLON
%token				SEMICOLON
%token				C_TYPE
%token				C_SINGLE
%token				C_BINARY
%token				C_NUMERIC
%token				C_TEXT
%token				C_OBJECTCLASS
%token				C_CREATE
%token				C_WRITE
%token				C_READ
%token				C_DELETE
%token				C_BASEDN
%token				C_BINDDN
%token				C_BINDPWD
%token				C_FRIENDLY
%token				C_VALIDATE
%token				C_OVERRIDE
%token				C_NODE
%token				C_DEFAULTNODE
%token				C_DEFAULTCLASS
%token				C_GLOBAL
%token				C_YES
%token				C_NO
%token				C_SMARTSAVE
%token				C_DEFAULTLANG
%token				C_BINDSERVER
%token				C_LOCALE
%token				C_FILE
%token				C_FILES
%token				C_FILENAME
%token				C_HEAD
%token				C_BODY
%token				C_TAIL
%token				C_APPEND
%token				C_MODE
%token				C_OWNER
%token				C_GROUP
%token				C_FILTER
%token				C_SORTBY
%token				C_ATTRLIST
%token				C_PASSWD
%token				C_CRYPTPW
%token				C_INTERNAL
%token				C_IZE_HTTP
%token				C_IZE_NBSP
%token				C_IZE_TIME
%token				C_IZE_MAP
%token				C_LOGIN
%token				C_ATTRIBUTE
%token				C_INCATTR
%token				C_START
%token				C_END
%token				C_MAINTAIN
%token				C_CREATOR
%token				C_CREATED
%token				C_MODIFIER
%token				C_MODIFIED
%token				C_PROGRAM
%token				C_RUN
%token				C_BEFORE
%token				C_AFTER
%token				C_MAP
%token				C_OBJECTATTRIBUTE
%token				C_ONPOSITIVE
%token				C_ONZERO
%token				C_ONNEGATIVE

%%
cfg_file:
	| sequence sc;

sequence: block
	| sequence sc block
	;

sc:
	| SEMICOLON;
cm:
	| COMMA;

block:
	C_TYPE C_SINGLE LB attr_list RB {
		lgba_i_addtype(TY_SINGLE, $4, NULL);
	}
	| C_TYPE C_BINARY TOK_STRING LB attr_list RB {
		lgba_i_addtype(TY_BINARY | TY_SINGLE, $5, $3);
	}
	| C_TYPE C_BINARY LB attr_list RB {
		lgba_i_addtype(TY_BINARY | TY_SINGLE, $4,
				"application/octet-stream");
	}
	| C_TYPE C_NUMERIC LB attr_list RB {
		lgba_i_addtype(TY_NUMERIC | TY_SINGLE, $4, NULL);
	}
	| C_TYPE C_NUMERIC ons cm LB attr_list RB {
		char **z=0;
		if(onzer || onneg || onpos) {
			z=(char **)sf_calloc(3, sizeof(char *));
			z[0]=onneg;
			z[1]=onzer;
			z[2]=onpos;
			onneg=onzer=onpos=NULL;
		};
		lgba_i_addtype(TY_NUMERIC | TY_SINGLE, $6, z);
	}
	| C_TYPE C_PASSWD LB attr_list RB {
		lgba_i_addtype(TY_PASSWD | TY_SINGLE, $4, NULL);
	}
	| C_TYPE C_CRYPTPW LB attr_list RB {
		lgba_i_addtype(TY_PASSWD | TY_SINGLE | TY_CRYPTPW, $4, NULL);
	}
	| C_TYPE C_TEXT LB attr_list RB {
		lgba_i_addtype(TY_TEXT, $4, NULL);
	}
	| C_TYPE C_MAP TOK_STRING LB attr_list RB {
		lgba_i_addtype(TY_MAP, $5, $3);
	}
	| C_OBJECTCLASS TOK_STRING LB class_defs sc RB {
		lgba_i_cfgaddclass($2, lgba_i_cf_tmp_acl_c, lgba_i_cf_tmp_acl_r, lgba_i_cf_tmp_acl_w, lgba_i_cf_tmp_acl_d);
		lgba_i_cf_tmp_acl_c=lgba_i_cf_tmp_acl_r=lgba_i_cf_tmp_acl_w=lgba_i_cf_tmp_acl_d=NULL;
	}
	| C_FRIENDLY TOK_STRING LB friendly_map sc RB {
		lgba_addlanguage($2, sarray(lgba_i_cf_tmp_frF, 0), sarray(lgba_i_cf_tmp_frT, 0));
		free($2);
		sfree(lgba_i_cf_tmp_frF);
		sfree(lgba_i_cf_tmp_frT);
		lgba_i_cf_tmp_frF=lgba_i_cf_tmp_frT=NULL;
	}
	| C_NODE TOK_STRING LB node_defs sc RB {
		leafnode *ln=lgba_i_node_head;
		if(!lgba_i_cf_tmp_a || !lgba_i_cf_tmp_b || !lgba_i_cf_tmp_c) {
			fprintf(stderr,
				"-ERR: Incomplete node definitions near line %d.\n", lgba_i_nline);
			return LGBA_CONF;
		};
		if(!ln) {
			ln=lgba_i_node_head=(leafnode *)sf_malloc(sizeof(leafnode));
		} else {
			while(ln->next) ln=ln->next;
			ln=ln->next=(leafnode *)sf_malloc(sizeof(leafnode));
		};
		ln->name=$2;
		ln->binddn=lgba_i_cf_tmp_a;
		ln->bindpwd=lgba_i_cf_tmp_b;
		ln->basedn=lgba_i_cf_tmp_c;
		ln->cur_dn=sf_strdup("");
		ln->bindserver=lgba_i_cf_tmp_bs;
		if(!ln->bindserver) ln->bindserver=sinit();
		if(!ln->bindserver->count) sadd(ln->bindserver, "127.0.0.1");
		ln->defaultclass=lgba_i_cf_tmp_e;
		ln->inc_attr=lgba_i_cf_tmp_f;
		if(lgba_i_cf_tmp_int_a >= lgba_i_cf_tmp_int_b) {
			lgba_i_cf_tmp_int_a=1000;
			lgba_i_cf_tmp_int_b=65000;
		};
		ln->inc_start=lgba_i_cf_tmp_int_a;
		ln->inc_end=lgba_i_cf_tmp_int_b;
		ln->mnt_created=lgba_i_cf_tmp_cd;
		ln->mnt_modified=lgba_i_cf_tmp_md;
		ln->mnt_creator=lgba_i_cf_tmp_cr;
		ln->mnt_modifier=lgba_i_cf_tmp_mr;
		ln->OA=lgba_i_cf_tmp_oa;
		ln->next=NULL;
		lgba_i_cf_tmp_a=lgba_i_cf_tmp_b=lgba_i_cf_tmp_c=lgba_i_cf_tmp_d=lgba_i_cf_tmp_e=lgba_i_cf_tmp_f=NULL;
		lgba_i_cf_tmp_int_a=lgba_i_cf_tmp_int_b=0;
		lgba_i_cf_tmp_cr=lgba_i_cf_tmp_cd=lgba_i_cf_tmp_mr=lgba_i_cf_tmp_md=lgba_i_cf_tmp_oa=NULL;
	}
	| C_VALIDATE LB validate_defs sc RB {
		if(lgba_i_val_head)
			fprintf(stderr,
			"-ERR: validate section defined more than once.\n");
		lgba_i_val_head=(Validate *)$3;
	}
	| C_OVERRIDE LB override_defs sc RB
	| C_GLOBAL LB global_defs sc RB
	| C_FILES LB files_defs sc RB
	| C_FILE TOK_STRING LB file_defs sc RB {
		file *fl=lgba_i_file_head;
		if(!fl) {
			fl=lgba_i_file_head=(file *)sf_malloc(sizeof(file));
		} else {
			while(fl->next) fl=fl->next;
			fl=fl->next=(file *)sf_malloc(sizeof(file));
		};
		fl->name=$2;
		fl->head=lgba_i_cf_tmp_a;
		fl->body=lgba_i_cf_tmp_b;
		fl->tail=lgba_i_cf_tmp_c;
		fl->filename=lgba_i_cf_tmp_d;
		fl->node=lgba_i_cf_tmp_e;
		fl->filter=lgba_i_cf_tmp_f?lgba_i_cf_tmp_f:sf_strdup("(|(!(objectclass=*))(objectclass=*))");
		fl->sortby=lgba_i_cf_tmp_g;
		fl->append=lgba_i_cf_tmp_int_a;
		fl->mode=lgba_i_cf_tmp_int_b;
		fl->owner=lgba_i_cf_tmp_int_c;
		fl->group=lgba_i_cf_tmp_int_d;
		fl->attrlist=lgba_i_cf_tmp_fattrlist?mkarray(lgba_i_cf_tmp_fattrlist, 0):NULL;
		fl->program=lgba_i_cf_tmp_scn;
		fl->next=NULL;
		if(!fl->filename ||
		(*fl->filename != '/' &&
		*fl->filename != '|')) {
			fprintf(stderr, "-ERR: Missing filename or invalid filename in file definition near line %d.\n", lgba_i_nline);
			return LGBA_CONF;
		};

		if(!fl->head && !fl->body && !fl->tail) {
			fprintf(stderr, "-ERR: head, body and tail left unspecified in file definition near line %d.\n", lgba_i_nline);
			return LGBA_CONF;
		};

		lgba_i_cf_tmp_a=lgba_i_cf_tmp_b=lgba_i_cf_tmp_c=lgba_i_cf_tmp_d=lgba_i_cf_tmp_e=lgba_i_cf_tmp_f=lgba_i_cf_tmp_g=lgba_i_cf_tmp_scn=NULL;
		lgba_i_cf_tmp_int_a=lgba_i_cf_tmp_int_b=lgba_i_cf_tmp_int_c=lgba_i_cf_tmp_int_d=0;
	}
	;

ons:
	ons_stmt
	| ons cm ons_stmt;

ons_stmt:
	C_ONNEGATIVE EQ TOK_STRING {
		if(onneg) free(onneg);
		onneg=$3;
	}
	| C_ONZERO EQ TOK_STRING {
		if(onzer) free(onzer);
		onzer=$3;
	}
	| C_ONPOSITIVE EQ TOK_STRING {
		if(onpos) free(onpos);
		onpos=$3;
	};

attr_list:
	TOK_STRING {
		slist *sl=sinit();
		sadd_attach(sl, $1, strlen($1));
		$$=sl;
	}
	| attr_list TOK_STRING {
		sadd_attach($1, $2, strlen($2));
		$$=$1;
	}
	| attr_list COMMA TOK_STRING {
		sadd_attach($1, $3, strlen($3));
		$$=$1;
	}
	;

av_list:
	avpair {
		$$.key = sinit();
		$$.val = sinit();
		sadd_attach($$.key, $1.a, strlen($1.a));
		sadd_attach($$.val, $1.v, strlen($1.v));
	}
	| av_list cm avpair {
		$$=$1;
		sadd_attach($$.key, $3.a, strlen($3.a));
		sadd_attach($$.val, $3.v, strlen($3.v));
	}
	;

class_defs: class_var | class_defs sc class_var;

class_var:
	C_CREATE attr_list LB av_list RB {
		lgba_i_addacl(&lgba_i_cf_tmp_acl_c, $2, $4.key, $4.val);
	}
	| C_READ attr_list LB attr_list RB {
		lgba_i_addacl(&lgba_i_cf_tmp_acl_r, $2, $4, $4);
	}
	| C_WRITE attr_list LB attr_list RB {
		lgba_i_addacl(&lgba_i_cf_tmp_acl_w, $2, $4, $4);
	}
	| C_DELETE attr_list LB av_list RB {
		lgba_i_addacl(&lgba_i_cf_tmp_acl_d, $2, $4.key, $4.val);
	};

node_defs: node_var | node_defs sc node_var;

node_var:
	C_BINDDN EQ TOK_STRING {
		if(lgba_i_cf_tmp_a) free(lgba_i_cf_tmp_a);
		lgba_i_cf_tmp_a=$3;
	}
	| C_BINDPWD EQ TOK_STRING {
		if(lgba_i_cf_tmp_b) free(lgba_i_cf_tmp_b);
		lgba_i_cf_tmp_b=$3;
	}
	| C_BASEDN EQ TOK_STRING {
		if(lgba_i_cf_tmp_c) free(lgba_i_cf_tmp_c);
		lgba_i_cf_tmp_c=$3;
	}
	| C_BINDSERVER EQ TOK_STRING {
		if(!lgba_i_cf_tmp_bs) lgba_i_cf_tmp_bs=sinit();
		sadd_attach(lgba_i_cf_tmp_bs, $3, strlen($3));
	}
	| C_DEFAULTCLASS EQ TOK_STRING {
		if(lgba_i_cf_tmp_e) free(lgba_i_cf_tmp_e);
		lgba_i_cf_tmp_e=$3;
	}
	| C_OBJECTATTRIBUTE EQ TOK_STRING {
		if(lgba_i_cf_tmp_oa) free(lgba_i_cf_tmp_oa);
		lgba_i_cf_tmp_oa=$3;
	}
	| inc_attr_var
	| C_INCATTR LB inc_attr_defs sc RB
	| C_MAINTAIN LB mnt_defs sc RB
	;

mnt_defs: mnt_var | mnt_defs sc mnt_var;
mnt_var:
	C_CREATED EQ TOK_STRING {
		if(lgba_i_cf_tmp_cd) free(lgba_i_cf_tmp_cd);
		lgba_i_cf_tmp_cd=$3;
	}
	| C_CREATOR EQ TOK_STRING {
		if(lgba_i_cf_tmp_cr) free(lgba_i_cf_tmp_cr);
		lgba_i_cf_tmp_cr=$3;
	}
	| C_MODIFIER EQ TOK_STRING {
		if(lgba_i_cf_tmp_mr) free(lgba_i_cf_tmp_mr);
		lgba_i_cf_tmp_mr=$3;
	}
	| C_MODIFIED EQ TOK_STRING {
		if(lgba_i_cf_tmp_md) free(lgba_i_cf_tmp_md);
		lgba_i_cf_tmp_md=$3;
	};

inc_attr_defs: inc_attr_var | inc_attr_defs sc inc_attr_var;
inc_attr_var:
	C_ATTRIBUTE EQ TOK_STRING {
		if(ecq($3, "objectclass")) {
			fprintf(stderr,
			"Config: attribute policy violation on line %d, ignoring.\n",
			lgba_i_nline);
			break;
		};
		lgba_i_cf_tmp_f=$3;
	}
	| C_START EQ TOK_INTEGER {
		lgba_i_cf_tmp_int_a=$3;
	}
	| C_END EQ TOK_INTEGER {
		lgba_i_cf_tmp_int_b=$3;
	}
	| C_START EQ TOK_STRING {
		lgba_i_cf_tmp_int_a=atoi($3);
		free($3);
	}
	| C_END EQ TOK_STRING {
		lgba_i_cf_tmp_int_b=atoi($3);
		free($3);
	};

friendly_map:
	avpair {
		if(!lgba_i_cf_tmp_frF) lgba_i_cf_tmp_frF=sinit();
		if(!lgba_i_cf_tmp_frT) lgba_i_cf_tmp_frT=sinit();
		sadd_attach(lgba_i_cf_tmp_frF, $1.a, strlen($1.a));
		sadd_attach(lgba_i_cf_tmp_frT, $1.v, strlen($1.v));
	}
	| C_FILE TOK_STRING {
		if(!lgba_i_cf_tmp_frF) lgba_i_cf_tmp_frF=sinit();
		if(!lgba_i_cf_tmp_frT) lgba_i_cf_tmp_frT=sinit();
		lgba_readavfile($2, &lgba_i_cf_tmp_frF, &lgba_i_cf_tmp_frT);
		free($2);
	}
	| friendly_map sc avpair {
		sadd_attach(lgba_i_cf_tmp_frF, $3.a, strlen($3.a));
		sadd_attach(lgba_i_cf_tmp_frT, $3.v, strlen($3.v));
	}
	| friendly_map sc C_FILE TOK_STRING {
		lgba_readavfile($4, &lgba_i_cf_tmp_frF, &lgba_i_cf_tmp_frT);
		free($4);
	};

avpair:
	TOK_STRING EQ TOK_STRING {
		$$.a = $1;
		$$.v = $3;
	}
	| TOK_STRING {
		$$.a=$1;
		$$.v=sf_strdup("");
	}
	;

validate_defs:
	validate_var {
		Validate *v;
		v=(Validate *)sf_malloc(sizeof(Validate));

		v->attrs=$1.attrs;
		v->exprs=$1.exprs;
		v->REs=$1.REs;
		v->next=NULL;

		$$=v;
	}
	| validate_defs SEMICOLON validate_var {
		Validate *v=(Validate *)$1;

		while(v->next) v=v->next;
		v=v->next=(Validate *)sf_malloc(sizeof(Validate));

		v->attrs=$3.attrs;
		v->exprs=$3.exprs;
		v->REs=$3.REs;
		v->next=NULL;

		$$=$1;
	}
	;

validate_var:
	attr_list EQ attr_list {
		$$.attrs=$1;
		$$.exprs=$3;
		$$.REs=sinit();
	}
	| attr_list EQ C_INTERNAL C_LOGIN {
		$$.attrs=$1;
		$$.exprs=sinit();
		sadd($$.exprs, "^[a-zA-Z]+[a-zA-Z0-9._-]*$");
		$$.REs=sinit();
	}
	;



override_defs:
	override_var {
		Override *ov=lgba_i_ovr_head;
		if(!ov)
			lgba_i_ovr_head=ov=(Override *)sf_malloc(sizeof(Override));
		else {
			while(ov->next) ov=ov->next;
			ov=ov->next=(Override *)sf_malloc(sizeof(Override));
		}

		ov->attr=$1.a;
		ov->to=$1.v;
		ov->func=$1.f;

		ov->next=NULL;
	}
	| override_defs sc override_var {
		Override *ov=lgba_i_ovr_head;
		while(ov->next) ov=ov->next;
		ov=ov->next=(Override *)sf_malloc(sizeof(Override));

		ov->attr=$3.a;
		ov->to=$3.v;
		ov->func=$3.f;

		ov->next=NULL;
	}
	;

override_var:
	avpair {
		$$.a=$1.a;
		$$.v=$1.v;
		$$.f=NULL;
	}
	| TOK_STRING EQ C_INTERNAL C_IZE_HTTP {
		$$.a=$1;
		$$.v=sf_strdup("");
		$$.f=lgba_i_httpize;
	}
	| TOK_STRING EQ C_INTERNAL C_IZE_TIME {
		$$.a=$1;
		$$.v=sf_strdup("");
		$$.f=lgba_i_timeize;
	}
	| TOK_STRING EQ C_INTERNAL C_IZE_MAP {
		$$.a=$1;
		$$.v=sf_strdup("");
		$$.f=lgba_i_mapize;
	}
	| TOK_STRING EQ C_INTERNAL C_IZE_NBSP {
		$$.a=$1;
		$$.v=sf_strdup("");
		$$.f=lgba_i_nbspize;
	}
	;

global_defs: global_var | global_defs sc global_var;

global_var:
	C_DEFAULTNODE EQ TOK_STRING {
		if(lgba_i_defaultnode) free(lgba_i_defaultnode);
		lgba_i_defaultnode=$3;
	}
	| C_SMARTSAVE EQ C_YES { lgba_i_smartsave=1; }
	| C_SMARTSAVE EQ C_NO { lgba_i_smartsave=0; }
	| C_DEFAULTLANG EQ TOK_STRING {
		if(lgba_i_defaultlang) free(lgba_i_defaultlang);
		lgba_i_defaultlang=$3;
	}
	| C_OBJECTATTRIBUTE EQ TOK_STRING {
		if(lgba_i_OA)
			free(lgba_i_OA);
		lgba_i_OA=$3;
	}
	| C_LOCALE EQ TOK_STRING {
		if(lgba_i_locale)
			free(lgba_i_locale);

		lgba_i_locale = $3;

		if(lgba_i_uselocale)
			lgba_internal_setlocale();

	}
	| C_FILES LB attr_list RB {
		if(lgba_i_files)
			sfree(lgba_i_files);
		lgba_i_files=$3;
	}
	;

file_defs: file_var | file_defs sc file_var;
file_var:
	C_NODE EQ TOK_STRING {
		if(lgba_i_cf_tmp_e) free(lgba_i_cf_tmp_e);
		lgba_i_cf_tmp_e=$3;
	}
	| C_APPEND EQ C_YES {
		lgba_i_cf_tmp_int_a=1;
	}
	| C_APPEND EQ C_NO {
		lgba_i_cf_tmp_int_a=0;
	}
	| C_MODE EQ TOK_INTEGER {
		lgba_i_cf_tmp_int_b=$3;
	}
	| C_OWNER EQ TOK_INTEGER {
		lgba_i_cf_tmp_int_c=$3;
	}
	| C_GROUP EQ TOK_INTEGER {
		lgba_i_cf_tmp_int_d=$3;
	}
	| C_FILENAME EQ TOK_STRING {
		if(lgba_i_cf_tmp_d) free(lgba_i_cf_tmp_d);
		lgba_i_cf_tmp_d=$3;
	}
	| C_HEAD EQ TOK_STRING {
		if(lgba_i_cf_tmp_a) free(lgba_i_cf_tmp_a);
		lgba_i_cf_tmp_a=$3;
	}
	| C_BODY EQ TOK_STRING {
		if(lgba_i_cf_tmp_b) free(lgba_i_cf_tmp_b);
		lgba_i_cf_tmp_b=$3;
	}
	| C_TAIL EQ TOK_STRING {
		if(lgba_i_cf_tmp_c) free(lgba_i_cf_tmp_c);
		lgba_i_cf_tmp_c=$3;
	}
	| C_FILTER EQ TOK_STRING {
		if(lgba_i_cf_tmp_f) free(lgba_i_cf_tmp_f);
		lgba_i_cf_tmp_f=$3;
	}
	| C_SORTBY EQ TOK_STRING {
		if(lgba_i_cf_tmp_g) free(lgba_i_cf_tmp_g);
		lgba_i_cf_tmp_g=$3;
	}
	| C_RUN C_PROGRAM EQ TOK_STRING {
		if(lgba_i_cf_tmp_scn) free(lgba_i_cf_tmp_scn);
		lgba_i_cf_tmp_scn=$4;
	}
	| C_ATTRLIST LB attr_list RB {
		lgba_i_cf_tmp_fattrlist=$3;
	}
	;

files_defs: files_var | files_defs sc files_var;
files_var:
	C_RUN C_BEFORE EQ TOK_STRING {
		if(lgba_i_file_before) free(lgba_i_file_before);
		lgba_i_file_before=$4;
	}
	| C_RUN C_AFTER EQ TOK_STRING {
		if(lgba_i_file_after) free(lgba_i_file_after);
		lgba_i_file_after=$4;
	};

%%

int yyerror(char *s) {
	fprintf(stderr, "Config parse error near line %d: %s\n", lgba_i_nline, s);
	return LGBA_CONF;
};
