#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <strfunc.h>

#include "gram.h"
#include "readcf.h"
#include "conf.h"
#include "intern.h"

extern char *lgba_i_cf;
extern char *lgba_i_cfpos;
extern off_t lgba_i_cfsize;
extern int	lgba_i_nline;

int lgba_i_brcount=0;

int lgba_i_toct(int i) {
    int s, d, e;

    s=i/100;
    d=(i-s*100)/10; 
    e=(i-s*100-d*10);
    i = (((s << 3) + d) << 3) + e;
    return i;  
};

#define CHECKRANGE if(w-buf >= buflen) { int z=w-buf; w=(buf=(char *)sf_realloc(buf, buflen=buflen << 1)) + z; }

int lgbacflex() {
	int n;
	char *p;

	if(lgba_i_cfpos - lgba_i_cf > lgba_i_cfsize) return 0;
	switch(*lgba_i_cfpos) {
		case '0': {
			int ishex = (lgba_i_cfpos[1] == 'x')?2:0;
			lgbacflval.tv_int=strtol(lgba_i_cfpos, NULL, 0);
			lgba_i_cfpos+=strspn(lgba_i_cfpos + ishex,
				"0123456789") + ishex;
			return TOK_INTEGER;
			};
		case '1': case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9':
			lgbacflval.tv_int=atoi(lgba_i_cfpos);
			lgba_i_cfpos+=strspn(lgba_i_cfpos, "0123456789");
			return TOK_INTEGER;
		case '\n':
			lgba_i_nline++;
			break;
		case '#':
			lgba_i_cfpos=strchr(lgba_i_cfpos, '\n');
			if(!lgba_i_cfpos) return 0; // End of file reached
			lgba_i_nline++;
			break;
		case '/':
			switch(lgba_i_cfpos[1]) {
				case '/':
					if(!(lgba_i_cfpos=
						strchr(lgba_i_cfpos, '\n')))
						return 0;
					lgba_i_nline++;
					break;
			case '*':
				{
					register char *p=lgba_i_cfpos+1;
					if(!(lgba_i_cfpos=strstr(p, "*/")))
						return 0;
					*lgba_i_cfpos=0;
					lgba_i_cfpos+=2;
					lgba_i_nline+=countchar(p, '\n');
				};
				break;
			};
			break;
		case '{': lgba_i_cfpos++; lgba_i_brcount++; return LB;
		case '}': lgba_i_cfpos++; lgba_i_brcount--; return RB;
		case '=': lgba_i_cfpos++; return EQ;
		case ',': lgba_i_cfpos++; return COMMA;
		case ':': lgba_i_cfpos++; return COLON;
		case ';': lgba_i_cfpos++; return SEMICOLON;
		case '*':
			lgba_i_cfpos++;
			lgbacflval.tv_char=sf_strdup("*");
			return TOK_STRING;
		case '\'':
		case '"':
			{

/* === */

            char *buf=(char *)sf_malloc(32);
            int  buflen=32;
            char *w=buf;
            int insng=0;
            int indbl=0;

            p=lgba_i_cfpos;

            while(1) {
            switch(*p) {
                case '\n':
					lgba_i_nline++;
                case ' ':
                case '\t':
                    if(insng || indbl) *w++=*p;
                    else if(w-buf) {
                        *w=0; lgbacflval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case NULL:
                    if(w-buf) {
                        lgba_i_cfpos=p;
                        *w=0; lgbacflval.tv_char=buf; return TOK_STRING;
                    }
                    return 0;
                case '\'':
                    if(indbl) *w++=*p;
                    else insng=insng?0:1;
                    if(!insng && !indbl) {
                        lgba_i_cfpos=p+1;
                        *w=0; lgbacflval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case '"':
                    if(insng) *w++=*p;
                    else indbl=indbl?0:1;
                    if(!insng && !indbl) {
                        lgba_i_cfpos=p+1;
                        *w=0; lgbacflval.tv_char=buf; return TOK_STRING;
                    }
                    break;
                case '\\':
                    if(insng) { *w++=*p; break; }
                    p++;
					switch(*p) {
						case '\n': lgba_i_nline++; break;
						case 'a': *w++='\a'; break;
						case 'b': w--; break;
						case 'e': *w++='\e'; break;
						case 'f': *w++='\f'; break;
						case 'n': *w++='\n'; break;
						case 'r': *w++='\r'; break;
						case 't': *w++='\t'; break;
						case 'v': *w++='\v'; break;
						case '\\': *w++='\\'; break;
						default: *w++=*p; break;
					}
                    break;
                default:
                    *w++=*p;
            }
                CHECKRANGE;
                p++;
            }

/* === */

			}
	};

	if((n=strspn(lgba_i_cfpos, "/-_!*@abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890")) > 0) {
		int code=0;
		p=strndup(lgba_i_cfpos, n);
		lgba_i_cfpos+=n;

		if(!lgba_i_brcount) {
			if(ecq(p, "objectclass")) code=C_OBJECTCLASS;
			if(eq(p, "type")) code=C_TYPE;
			if(eq(p, "password")) code=C_PASSWD;
			if(eq(p, "passwd")) code=C_PASSWD;
			if(eq(p, "cryptpw")) code=C_CRYPTPW;
			if(eq(p, "cryptpwd")) code=C_CRYPTPW;
			if(eq(p, "file")) code=C_FILE;
			if(eq(p, "files")) code=C_FILES;
			if(eq(p, "map")) code=C_MAP;
			if(ecq(p, "onzero")) code=C_ONZERO;
			if(ecq(p, "onpositive")) code=C_ONPOSITIVE;
			if(ecq(p, "onnegative")) code=C_ONNEGATIVE;
		};

		if(lgba_i_brcount == 1) {
			if(eq(p, "run")) code=C_RUN;
			if(eq(p, "program")) code=C_PROGRAM;
			if(eq(p, "after")) code=C_AFTER;
			if(eq(p, "before")) code=C_BEFORE;
			if(eq(p, "map")) code=C_MAP;
		};

		if(lgba_i_brcount == 2) {
			if(eq(p, "creator")) code=C_CREATOR;
			if(eq(p, "created")) code=C_CREATED;
			if(eq(p, "modifier")) code=C_MODIFIER;
			if(eq(p, "modified")) code=C_MODIFIED;
		};

		if(eq(p, "single")) code=C_SINGLE;
		if(eq(p, "binary")) code=C_BINARY;
		if(eq(p, "override")) code=C_OVERRIDE;
		if(eq(p, "numeric")) code=C_NUMERIC;
		if(eq(p, "text")) code=C_TEXT;
		if(eq(p, "create")) code=C_CREATE;
		if(eq(p, "read")) code=C_READ;
		if(eq(p, "write")) code=C_WRITE;
		if(eq(p, "delete")) code=C_DELETE;
		if(eq(p, "basedn")) code=C_BASEDN;
		if(eq(p, "binddn")) code=C_BINDDN;
		if(eq(p, "bindpwd")) code=C_BINDPWD;
		if(eq(p, "friendly")) code=C_FRIENDLY;
		if(eq(p, "validate")) code=C_VALIDATE;
		if(eq(p, "node")) code=C_NODE;
		if(eq(p, "defaultnode")) code=C_DEFAULTNODE;
		if(eq(p, "global")) code=C_GLOBAL;
		if(eq(p, "YES") || eq(p, "ON")) code=C_YES;
		if(eq(p, "NO") || eq(p, "OFF")) code=C_NO;
		if(eq(p, "smartsave")) code=C_SMARTSAVE;
		if(eq(p, "defaultlang")) code=C_DEFAULTLANG;
		if(eq(p, "bindserver")) code=C_BINDSERVER;
		if(eq(p, "locale")) code=C_LOCALE;
		if(eq(p, "filename")) code=C_FILENAME;
		if(eq(p, "head")) code=C_HEAD;
		if(eq(p, "body")) code=C_BODY;
		if(eq(p, "tail")) code=C_TAIL;
		if(eq(p, "append")) code=C_APPEND;
		if(eq(p, "mode")) code=C_MODE;
		if(eq(p, "owner")) code=C_OWNER;
		if(eq(p, "group")) code=C_GROUP;
		if(eq(p, "filter")) code=C_FILTER;
		if(eq(p, "sortby")) code=C_SORTBY;
		if(eq(p, "attrlist")) code=C_ATTRLIST;
		if(eq(p, "defaultclass")) code=C_DEFAULTCLASS;
		if(ecq2(p, "httpize")) code=C_IZE_HTTP;
		if(ecq2(p, "nbspize")) code=C_IZE_NBSP;
		if(ecq2(p, "timeize")) code=C_IZE_TIME;
		if(ecq2(p, "mapize")) code=C_IZE_MAP;
		if(eq(p, "internal")) code=C_INTERNAL;
		if(eq(p, "increment_attr")) code=C_INCATTR;
		if(eq(p, "attribute")) code=C_ATTRIBUTE;
		if(eq(p, "start")) code=C_START;
		if(eq(p, "end")) code=C_END;
		if(eq(p, "LOGIN")) code=C_LOGIN;
		if(eq(p, "maintain")) code=C_MAINTAIN;
		if(eq(p, "objectattribute")) code=C_OBJECTATTRIBUTE;

		if(code) { free(p); return code; };

		lgbacflval.tv_char=p;
		return TOK_STRING;
	}

	lgba_i_cfpos++;
	return lgbacflex();
}

