#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <lber.h>
#include <ldap.h>
#include <string.h>
#include <time.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include <strfunc.h>

#include "lgba.h"
#include "friendly.h"
#include "readcf.h"
#include "pwd.h"
#include "file.h"
#include "getlists.h"
#include "intern.h"

int
lgba_i_htmlmode = 0;

extern int lgba_i_override;

extern char *_lgba_i_loadfilter;

extern LDAP *ld;

int
lgba_ctl(int cmd, long *arg) {

	if(!arg)
			return LGBA_VALUE;

	switch(cmd) {
	case LCTL_GET_HTMLMODE:
		*arg = lgba_i_htmlmode;
		break;
	case LCTL_SET_HTMLMODE:
		lgba_i_htmlmode = (*arg)?1:0;
		break;
	case LCTL_GET_OVERRIDEMODE:
		*arg = lgba_i_override;
		break;
	case LCTL_SET_OVERRIDEMODE:
		lgba_i_override = (*arg)?1:0;
		break;
	case LCTL_GET_USE_LOCALE:
		*arg = lgba_i_uselocale;
		break;
	case LCTL_SET_USE_LOCALE:
		lgba_i_uselocale = (*arg)?1:0;
		if(*arg && lgba_i_locale)
			lgba_internal_setlocale();
		break;
	case LCTL_GET_SIZELIMIT:
#ifdef LDAP_VERSION3
		{
			int i;
			(void) ldap_get_option (ld, LDAP_OPT_SIZELIMIT, &i);
			*arg=i;
		};
#else
		*arg=ld->ld_sizelimit;
#endif /* LDAP_VERSION3_API */
		break;
	case LCTL_SET_SIZELIMIT:
#ifdef LDAP_VERSION3
		{
			int i = *arg;
			(void) ldap_set_option (ld, LDAP_OPT_SIZELIMIT, &i);
		};
#else
		ld->ld_sizelimit = *arg;
#endif
		break;
	case LCTL_GET_LOADFILTER:
		if(arg)
			*arg = (long)_lgba_i_loadfilter;
		return 0;
	case LCTL_SET_LOADFILTER:
		if(!arg) {
			return -1;
		} else {
			char *tmp;
			tmp = (char *)sf_strdup((char *)arg);
			if(!tmp) {
				lgba_errno = LGBA_UNKNOWN;
				return -1;
			}
			if(_lgba_i_loadfilter)
				free(_lgba_i_loadfilter);
			_lgba_i_loadfilter = tmp;
			return 0;
		}

	default:
		return -1;
	};

	return LGBA_NOERR;
};




