#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <lber.h>
#include <ldap.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#include "lgba.h"
#include "readcf.h"
#include "intern.h"

extern LDAP *ld;

int
lgba_exists(const char *object) {
	char *at;
	char *avl[]={lgba_i_node->OA, NULL};
	LDAPMessage *res;
	long sizelimit;
	long k;

	if(!ld && lgba_open()) return lgba_errno;
	if(!object) return lgba_errno=LGBA_VALUE;

	at=(char *)sf_malloc(strlen(lgba_i_node->OA) + strlen(object) + 5);
	sprintf(at, "(%s=%s)", lgba_i_node->OA, object);

	lgba_ctl(LCTL_GET_SIZELIMIT, &sizelimit);
	k = 2;
	lgba_ctl(LCTL_SET_SIZELIMIT, &k);

	k=ldap_search_s(ld, lgba_current_dn(), LDAP_SCOPE_ONELEVEL, at,
	avl, 1, &res);
	free(at);

	lgba_ctl(LCTL_SET_SIZELIMIT, &sizelimit);

#ifdef	LDAP_NAME_ERROR
	if(LDAP_NAME_ERROR(k))
		return lgba_errno=LGBA_NOTFOUND;
#else
	if(NAME_ERROR(k))
		return lgba_errno=LGBA_NOTFOUND;
#endif

	switch(k) {
	case 0:
		break;
	case LDAP_SERVER_DOWN:
		if(lgba_open()) return lgba_errno;
		return load(object);
	default:
		return lgba_errno=LGBA_LDAP;
	};

	k=ldap_count_entries(ld, res); ldap_msgfree(res);
	if(k <= 0) return lgba_errno=LGBA_NOTFOUND;
	else if(k > 1) return lgba_errno=LGBA_TOOMANY;

	return 0;
};
