#include <stdio.h>
#include <string.h>
#include <locale.h>

#include "strfunc.h"
#include "friendly.h"
#include "readcf.h"
#include "intern.h"

int lgba_i_uselocale=1;
char *lgba_i_locale=NULL;

int lgba_internal_setlocale() {
        (void)setlocale(LC_ALL, lgba_i_locale?lgba_i_locale:"C");
        return 0;
};

Flang *lgba_i_flang_head=NULL;
Flang *lgba_i_lang=NULL;

char *lgba_setlang(char *l) {
	Flang *fl=lgba_i_flang_head;

	/* Reset language. */
	if(!l) l=lgba_i_defaultlang;
	if(!l) return (lgba_i_lang=fl)->name;

	while(fl) {
		if(ecq(fl->name, l)) {
			lgba_i_lang=fl;
			if(!lgba_i_defaultlang)
			_lgba_internal_warn("!NOTE: Language set to \"%s\".", lgba_i_lang->name);
			return (lgba_i_defaultlang=lgba_i_lang->name);
		};
		fl=fl->next;
	}

	_lgba_internal_warn("-ERR: No such language defined: \"%s\".", l);
	return lgba_i_lang?lgba_i_lang->name:NULL;
}

char *lgba_map_friendly(const char *from) {
	char *p;

	if(!lgba_i_lang) lgba_setlang(NULL);

	p=scget2(lgba_i_lang->keys, from, lgba_i_lang->vals);

	return p?p:(char *)from;
}

void lgba_addlanguage(const char *name, char **keys, char **vals) {
	Flang *fl=lgba_i_flang_head;
	if(!fl) {
		lgba_i_flang_head=fl=(Flang *)sf_calloc(1, sizeof(Flang));
		fl->name=sf_strdup(name);
		fl->keys=sinit();
		fl->vals=sinit();
	} else {
		while(fl->next) {
			if(eq(fl->name, name)) break;
			fl=fl->next;
		}
		if(!eq(fl->name, name)) {
			fl->next=(Flang *)sf_calloc(1, sizeof(Flang));
			fl=fl->next;
			fl->name=sf_strdup(name);
			fl->keys=sinit();
			fl->vals=sinit();
		}
	};
	while(*keys) sadd(fl->keys, *keys++);
	while(*vals) sadd(fl->vals, *vals++);
}

void lgba_addfriendly(char *key, char *val) {
	if(!lgba_i_lang) return;
	if(!key || !val) return;
	sadd(lgba_i_lang->keys, key);
	sadd(lgba_i_lang->vals, val);
}

