
#ifndef	__STDC__
#define	__STDC__
#endif

#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <lber.h>
#include <ldap.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef	HAVE_FNMATCH_H
#include <fnmatch.h>
#endif

#include "lgba.h"
#include "friendly.h"
#include "readcf.h"
#include "pwd.h"
#include "file.h"

acl *
lgba_i_getcreatelist(const char *cls) {
	oca *oc;
	acl *ac;
	slist *us;
	int i;

	if(!cls) (char *)cls=lgba_i_node->defaultclass;
	if(!(oc=lgba_i_findclass(cls))) return NULL;
	ac=oc->create;

	while(ac) {
		us=ac->users;
		for(i=0; i < us->count; i++)
			if(!fnmatch(us->list[i], lgba_i_user, 0))
				return ac;
		ac=ac->next;
	}

	return ac;
};

acl *
lgba_i_getdeletelist(const char *cls) {
	oca *oc;
	acl *ac;
	slist *us;
	int i;

	if(!cls) (char *)cls=lgba_i_node->defaultclass;
	if(!(oc=lgba_i_findclass(cls))) return NULL;

	ac=oc->delete;

	while(ac) {
		us=ac->users;
		for(i=0; i < us->count; i++)
			if(fnmatch(us->list[i], lgba_i_user, 0) == 0)
				return ac;
		ac=ac->next;
	}

	return ac;
};

char **
lgba_getwritelist() {
	oca *oc;
	acl *ac;
	slist *sl=NULL;
	char **vp;
	char **tp;
	slist *us;
	int i;

	if(!loaded.dn) return NULL;

	if(!sl) sl=sinit();
	else sclear(sl);

	if(!loaded.objectclass) return NULL;

	for(vp = loaded.objectclass->list; *vp; vp++) {
		if(!(oc=lgba_i_findclass(*vp))) return NULL;
		ac=oc->write;
		while(ac) {
			us=ac->users;
			for(i=0; i < us->count; i++)
			if(fnmatch(us->list[i], lgba_i_user, 0) == 0) {
				if((tp=sarray(ac->attrlist, 0))) {
				tp--;
				while(*(++tp))
					if(scfind(sl, *tp) == -1)
						sadd(sl, *tp);
				};
				
			};
			ac=ac->next;
		};
	};

	return sarray(sl, 0);
};


