#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <lber.h>
#include <ldap.h>
#include <string.h>

#ifdef  HAVE_CONFIG_H
#include "config.h"
#endif

#include <strfunc.h>

#include "lgba.h"
#include "readcf.h"
#include "intern.h"

extern int lgba_errno;

extern LDAP *ld;

int
lgba_i_fillanswer(answer *answer, LDAPMessage *en) {
	BerElement *bpt;
	struct berval **bv, **bvt;
	slist *sl;
	char *at;

	if(!answer || !en)
		return -1;

	answer->count=0;
    answer->dn=ldap_get_dn(ld, en);
    answer->object=NULL;
    answer->list=(avt **)sf_realloc(answer->list, 3 * sizeof(avt *));
    at=ldap_first_attribute(ld, en, &bpt);
    while(at) {
		answer->list=(avt **)sf_realloc(answer->list, sizeof(avt *) *
			(answer->count+2));
        answer->list[answer->count]=(avt *)sf_calloc(1, sizeof(avt));
        answer->list[answer->count]->key=sf_strdup(at);
        answer->list[answer->count]->vals=sl=sinit();
        if((bv=ldap_get_values_len(ld, en, at))) {
            for(bvt = bv; *bvt; bvt++) {
                sadd_attach(sl, (*bvt)->bv_val, (*bvt)->bv_len);
                free(*bvt);
            };
            free(bv);
        };

        if(ecq2(at, "objectclass")) {
            answer->objectclass = 
				scopy(answer->list[answer->count]->vals);
        } else if(ecq2(at, lgba_i_node->OA)) {
			if(answer->object)
				free(answer->object);
            answer->object =
                sf_strdup(answer->list[answer->count]->vals->list[0]);
        };

        at=ldap_next_attribute(ld, en, bpt);
        answer->count++;
    };
    answer->list[answer->count]=NULL;

    return LGBA_NOERR;

};
