
#ifndef	__STDC__
#define	__STDC__
#endif

#include <sys/types.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef	HAVE_FCNTL_H
#include <fcntl.h>
#endif

#ifdef	HAVE_FNMATCH_H
#include <fnmatch.h>
#endif

#ifdef	HAVE_MMAP
#include <sys/mman.h>
#endif

#include <strfunc.h>

#include "readcf.h"
#include "lgba.h"
#include "intern.h"

char *lgba_i_OA=NULL;
typestr *lgba_i_tphead=NULL;
oca *lgba_i_ocahead=NULL;
slist *lgba_i_classnames=NULL;
Validate *lgba_i_val_head=NULL;
Override *lgba_i_ovr_head=NULL;
leafnode *lgba_i_node_head;
leafnode *lgba_i_node=NULL;
file *lgba_i_file_head;
slist *lgba_i_files=NULL;

char *lgba_i_defaultnode=NULL;
char *lgba_i_defaultlang=NULL;
int  lgba_i_smartsave=1;
char *lgba_i_ldapserver=NULL;
char *lgba_i_user="nobody";

char *lgba_i_cf;
char *lgba_i_cfpos;
off_t lgba_i_cfsize;

int lgbacfparse();

extern int lgba_i_nline;
extern int lgba_i_brcount;

int lgba_dn_dirty=1;

int lgba_readcf(char *cfname) {
	int fd;
	struct stat sb;

#ifndef OBJECTATTRIBUTE
#define	OBJECTATTRIBUTE	"object"
#endif

	if(!lgba_i_OA)
		lgba_i_OA=sf_strdup(OBJECTATTRIBUTE);

#ifndef LGBACONFIG
#define LGBACONFIG	"/usr/local/etc/lgba.conf"
#endif

	if(!cfname) cfname=LGBACONFIG;

	if((fd=open(cfname, O_RDONLY)) == -1 || fstat(fd, &sb)) {
		_lgba_internal_warn("-ERR: Can't open config file.");
		return LGBA_CONF;
	};

	lgba_i_cfsize=sb.st_size+1;
	
	if(!(lgba_i_cfpos=lgba_i_cf=(char *)mmap(NULL, lgba_i_cfsize, PROT_READ | PROT_WRITE, MAP_PRIVATE, fd, 0))) {
		_lgba_internal_warn("Can't mmap() config file.");
		return LGBA_CONF;
	}

	lgba_i_nline=1;
	lgba_i_brcount=0;

	if(lgbacfparse()) return LGBA_CONF;

	// setting default node.
	if(!lgba_i_node_head) {
		_lgba_internal_warn("-ERR: no nodes defined.");
		return LGBA_CONF;
	}

	if(!lgba_i_defaultnode) {
		lgba_i_node=lgba_i_node_head;
		lgba_i_defaultnode=sf_strdup(lgba_i_node->name);
	} else {
		leafnode *n=lgba_i_node_head;
		while(n) {
			if(ecq(n->name, lgba_i_defaultnode)) { lgba_i_node=n; break; };
			n=n->next;
		};
		if(!lgba_i_node) {
			lgba_i_node=lgba_i_node_head;
			_lgba_internal_warn("~WARN: default node '%s' not found, using '%s'.",
				lgba_i_defaultnode, lgba_i_node->name);
		}
	}


	{
	leafnode *n=lgba_i_node_head;
	while(n) {
		if(!n->OA) n->OA=sf_strdup(lgba_i_OA);
		n=n->next;
	};
	}

	if(lgba_i_defaultlang) {
		lgba_setlang(lgba_i_defaultlang);
		free(lgba_i_defaultlang);
		lgba_i_defaultlang=NULL;
	};

	return 0;
}

void
lgba_i_addtype(int t, slist *sl, void *other) {
	typestr *tp=lgba_i_tphead;

	if(!tp) {
		tp=lgba_i_tphead=(typestr *)sf_malloc(sizeof(typestr));
	} else {
		while(tp->next) tp=tp->next;
		tp=tp->next=(typestr *)sf_malloc(sizeof(typestr));
	};

	tp->tp=t;
	tp->attr=sl;
	tp->other=other;
	tp->next=NULL;

   	if(sl) {
		int i;
		char *c;
		for(i = 0; i < sl->count; i++)  {
			if((c = sl->list[i])) {
				while(*c) {
					*c = tolower(*c);
					c++;
				}
			}
		}
	}

};

int
lgba_gettype(const char *ap) {
	int res=0;
	typestr *tp=lgba_i_tphead;
	char **vp;
	register char *a = (char *)ap;

#ifndef	FNM_CASEFOLD
	register char *c;
	if(!a)
		return 0;
	a = (char *)alloca(strlen(ap) + 1);
	if(!a) abort(); /* Stack overflow */
	for(c = a; *c; c++, ap++)
		*c = tolower(*ap);
#else
	if(!a)
		return 0;
#endif

	while(tp) {
		if(!tp->attr || !(vp = tp->attr->list))
			continue;

		for(; *vp; vp++)
			if(fnmatch(*vp, a,
#ifdef	FNM_CASEFOLD
			FNM_CASEFOLD
#else
			0
#endif
			) == 0) res |= tp->tp;

		tp=tp->next;
	}

	return res;
};

void 
*lgba_gettypespec(const char *ap) {
	typestr *tp=lgba_i_tphead;
	char **vp;
	register char *a = (char *)ap;

#ifndef	FNM_CASEFOLD
	register char *c;
	if(!a)
		return 0;
	a = (char *)alloca(strlen(a) + 1);
	if(!a) abort();	/* Stack overflow */
	for(c = a; *c; c++, ap++)
		*c = tolower(*ap);
#else
	if(!a)
		return 0;
#endif


	while(tp) {
		if(!tp->attr || !(vp = tp->attr->list))
			continue;
		for(; *vp; vp++)
			if(tp->other && (fnmatch(*vp, a,
#ifdef	FNM_CASEFOLD
			FNM_CASEFOLD
#else
			0
#endif
			) == 0))
				return tp->other;
		tp=tp->next;
	}

	return NULL;
};

int
lgba_i_addacl(acl **al, slist *users, slist *attrlist, slist *defslist) {
	acl *a;

	if(!*al) {
		a=*al=(acl *)sf_malloc(sizeof(acl));
	} else {
		a=*al;
		while(a->next) a=a->next;
		a=a->next=(acl *)sf_malloc(sizeof(acl));
	}

	if(scfind(users, "") != -1) {
		_lgba_internal_warn("-ERR: Config: Access list cannot be empty.");
		return LGBA_VALUE;
	};

	a->users=users;
	a->attrlist=attrlist;
	a->defaults=defslist;
	a->next=NULL;

   	if(users) {
		int i;
		char *c;
		for(i = 0; i < users->count; i++)  {
			if((c = users->list[i])) {
				while(*c) {
					*c = tolower(*c);
					c++;
				}
			}
		}
	}

#ifndef	FNM_CASEFOLD
   	if(attrlist) {
		int i;
		char *c;
		for(i = 0; i < attrlist->count; i++)  {
			if((c = attrlist->list[i])) {
				while(*c) {
					*c = tolower(*c);
					c++;
				}
			}
		}
	}
#endif

	return 0;
}

char **
lgba_get_classnames() {
	return sarray(lgba_i_classnames, 0);
}

void
lgba_i_cfgaddclass(char *classname, acl *c, acl *r, acl *w, acl *d) {
	oca *o;

	if(!lgba_i_ocahead) {
		o=lgba_i_ocahead=(oca *)sf_malloc(sizeof(oca));
		lgba_i_classnames=sinit();
	} else {
		o=lgba_i_ocahead;
		while(o->next) o=o->next;
		o=o->next=(oca *)sf_malloc(sizeof(oca));
	}

	sadd(lgba_i_classnames, classname);

	o->classname=classname;
	o->create=c;
	o->delete=d;
	o->read=r;
	o->write=w;
	o->next=NULL;

	if(c) {
		char **sl=sarray(c->attrlist, 0);
		char **dl=sarray(c->defaults, 0);
		while(*sl) {
			if(ecq2(*sl, "objectclass") && !**dl) {
				free(*dl);
				*dl=sf_strdup(classname);
			};
			sl++; dl++;
		}
	}
}

int
lgba_readavfile(const char *fname, slist **a, slist **b) {
	FILE *f;
	sbuf *sb;
	char *p;

	if(!*a) *a=sinit();
	if(!*b) *b=sinit();

	if(!fname || !(f=fopen(fname, "r"))) return -1;

	sb = sbuf_init();
	while((sbuf_zero(sb) == 0) && (p=sbuf_fgets(sb, f))) {

		while(*p == ' ' || *p == '\t') p++;
		if(!*p || *p == '#') continue;

		p[sb->len - 1] = 0;

		while(*p) {
		switch(*p) {
			case '#':
				*p--=0;
				sadd(*b, sb->buf);
				break;
			case ':':
			case '\t':
				*p++=0;
				while(*p == ' ' || *p == '\t' || *p == ':') p++;
				sadd(*b, p);
				*p--=0;
				break;
		}
		p++;
		}

		sadd(*a, sb->buf);
		if((*a)->count != (*b)->count) sadd(*b, sb->buf);
	}

	fclose(f);

	sbuf_free(sb);

	return 0;
}

char *lgba_internal_numericvalue(const char *key, const char *val) {
	char **ons;
	int oldval;
	int value;
	int what2do=0;

	if(!val)
		return NULL;

	while(*val == ' ')
		val++;

	oldval=atoi(getattr(key));

	switch(*val) {
		case '+': what2do=1; val++; break;
		case '-': what2do=-1; val++; break;
		case '=': what2do=0; val++; break;
	};

	value=atoi(val);

	for(; *val; val++)
	switch(*val) {
		case 'm': value*=60; break;
		case 'k': value*=1024; break;
		case 'h': value*=3600; break;
		case 'd': value*=86400; break;
		case 'w': value*=604800; break;
		case 'M': value*=1048576; break;
		case 'y': value*=31536000; break;
	};

	if(what2do)
		value = oldval + what2do * value;

	if((ons=lgba_gettypespec(key))) {
		int z=-2;
		if(oldval >= 0 && value < 0 && ons[0]) z=-1;
		if(oldval != 0 && value == 0 && ons[1]) z=0;
		if(oldval <= 0 && value > 0 && ons[2]) z=1;
		switch(z) {
			case -1: xsystem(getformat(ons[0])); break;
			case 0: xsystem(getformat(ons[1])); break;
			case 1: xsystem(getformat(ons[2])); break;
		};
	};

	return genstr(value);
};

char *getmodifierattributename() { return lgba_i_node->mnt_modifier; };
char *getmodifiedattributename() { return lgba_i_node->mnt_modified; };
char *getcreatorattributename() { return lgba_i_node->mnt_creator; };
char *getcreatedattributename() { return lgba_i_node->mnt_created; };


/*
 * Get LGBA nodes list
 */
slist *
lgba_nodes() {
	leafnode *cn;
	static slist *sl;

	if(!sl) {
		sl = sinit();
		if(!sl)
			return NULL;
	} else {
		sclear(sl);
	}

	for(cn = lgba_i_node_head; cn; cn = cn->next)
		sadd(sl, cn->name);

	return sl;
}


