
/*
** Copyright (c) by Vasily Karyaev <basil@ulstu.ru>
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include <ctype.h>

#include "lgba.h"
#include "intern.h"


static	struct	SortBy	**sortby;
static	char	*empty[]={ NULL };

extern	int lgba_srt(const char *a, const char *b);

struct	srtthing {
	answer	*ans;
	char ***vals;
	char **dn;
};


static	int cmpChVect(
	char **a,
	char **b,
	int	(*cmp)(const char *a,const char *b),
	const char *dflt
) {
	if(!a) a=empty;
	if(!b) b=empty;
	while(*a || *b) {
	  const char *s1=(*a)? *a++ : dflt ;
	  const char *s2=(*b)? *b++ : dflt ;
	  int res=cmp(s1,s2);
	  if(res) return res;
	}
	return 0;
}

static int lgba_et_cmp(const void *aa,const void *bb) {

	struct srtthing *a=(struct srtthing*)aa;
	struct srtthing *b=(struct srtthing*)bb;
	int i,res;

	if(sortby) for(i=0;sortby[i];i++) {
	  if(a->vals[i]==empty) 
	    a->vals[i]=sarray(getattr2_s(a->ans,(char*)sortby[i]->attr), 0);
	  if(b->vals[i]==empty) 
	    b->vals[i]=sarray(getattr2_s(b->ans,(char*)sortby[i]->attr), 0); 
	  res=cmpChVect(a->vals[i],b->vals[i],sortby[i]->cmp,sortby[i]->dflt);
	  if(res) return res;
	}

	if(a->dn==empty)
		a->dn=lgba_explode_dn(a->ans->dn);
	if(b->dn==empty)
		b->dn=lgba_explode_dn(b->ans->dn);
	return cmpChVect(a->dn, b->dn, lgba_srt, "");		
}

int
lgba_sort_entries2( answer **answers, int count, struct SortBy **srtb ) {
	int i, fields;
	struct srtthing *st;

	if(count < 0) return -1;
	if(count < 2) return 0;

	sortby=srtb;
	
	fields=0;
	if(sortby) {
	  struct SortBy **sbp=sortby;
	  for(;*sbp;sbp++) fields++;
	}

	st=sf_malloc(count*sizeof(struct srtthing));

	for(i=0;i<count;i++) { 
	  int j;
	  st[i].ans = answers[i];
	  st[i].dn = empty;
	  st[i].vals=sf_malloc(fields*sizeof(char**));
	  for(j=0; j< fields; j++)
		st[i].vals[j]=empty;
	}

	qsort(st, count, sizeof(struct srtthing), lgba_et_cmp);

	for (i = 0; i < count; i++)
	  answers[i]=st[i].ans;

	free((char *)st);

	return 0;
}
